typedef	long	time_t;			/* ugly! */

#include <stdio.h>
#include <types.h>
#include <task.h>
#include <q.h>
#include <netq.h>
#include <net.h>
#include <custom.h>
#include <netbuf.h>
#include <icmp.h>
#include <ip.h>
#include <timer.h>
#include <ntcp.h>
#include <ntcpblk.h>

/* This routine is called to initialize the TCP.  It calls a bunch of
 * lower level protocol-initialization modules, opens a connection to
 * internet, and sets up a pseudo header for outgoing checksum calculations,
 * which is used by all subsequent send processes.
 */

int tcp_init(stksize)
	int stksize; {

	Netinit(stksize);
	in_init();
	IcmpInit();
	GgpInit();
	UdpInit();
	nm_init();

	tcppsnt =			/* initially, no pkts sent */
	tcpprcv =			/* or received */ 
	tcpbsnt =			/* no bytes sent */
	tcpbrcv =			/* foreign host sent no bytes */
	tcprack =			/* we acked no bytes of foreign host*/
	tcpresend =			/* number of resend timeouts */
	bd_chk =			/* # bad checksums */
	ign_win = 0;			/* # time he ignored our window */
	if((tcpfd = in_open(TCPPROT, tcp_rcv, 0)) == 0) {
#ifdef	TCDBG
		printf("TCP_INIT: could not open to internet\n");
#endif
		return(FALSE);
	}

	/* allocate and set up psudoheader for incoming packets */
	iphp.tp_zero = 0;
	iphp.tp_pro = TCPPROT;
	return(TRUE);
}
